static const char _rcsid_[]="$Id: procan.c,v 1.5 2001/08/03 17:56:25 hermi Exp $";
/* Copyright Gerhard Rieger 2001 */
/* Published under the GNU General Public License V.2, see file COPYING */

/* the subroutine procan makes a "PROCess ANalysis". It gathers information
   about the process environment it is running in without modifying its state
   (almost).
 */

#if 0

#include "config.h"

#undef WITH_UNIX
#undef WITH_TCP
#undef WITH_UDP
#undef WITH_IP4
#undef WITH_IP6
#undef WITH_SOCKS4
#undef WITH_SOCKS4A

#include "xioconfig.h"	/* what features are enabled */

#include <errno.h>	/* strerror(), strchr() */
#include <string.h>	/* strerror(), strchr() */
#include <stdio.h>	/* strerror(), strchr() */
#if HAVE_FCNTL_H
#include <fcntl.h>	/* open(), O_RDWR */
#endif
#include <unistd.h>	/* getpid() */
#include <termios.h>	/* struct termios */
#include <sys/stat.h>	/* struct stat, stat(), open() */
#if HAVE_SYS_TIME_H
#include <sys/time.h>	/* struct timeval, select() */
#endif
#if HAVE_SYS_SELECT_H
#include <sys/select.h>	/* select(), fdset on AIX 4.1 */
#endif

#include "mytypes.h"
#include "compat.h"
#include "error.h"
#if 0
struct sockaddr;	/* prevent gcc from spitting silly warning */
struct sockaddr_un;	/* prevent gcc from spitting silly warning */
struct sockaddr_in;	/* prevent gcc from spitting silly warning */
struct sockaddr_in6;	/* prevent gcc from spitting silly warning */
#undef WITH_SOCKET
#endif

#else

#include "xiosysincludes.h"
#include "mytypes.h"
#include "compat.h"
#include "error.h"
#include "sycls.h"
#include "sysutils.h"
#include "filan.h"

#include "procan.h"

#endif


int procan(FILE *outfile) {

   /* controlling terminal */
   fprintf(outfile, "process id = "F_pid"\n", Getpid());
   fprintf(outfile, "process parent id = "F_pid"\n", Getppid());
   fprintf(outfile, "process group id = "F_pid"\n", Getpgrp());
   fprintf(outfile, "process group id if fg process / stdin = "F_pid"\n", Tcgetpgrp(0));
   fprintf(outfile, "process group id if fg process / stdout = "F_pid"\n", Tcgetpgrp(1));
   fprintf(outfile, "process group id if fg process / stderr = "F_pid"\n", Tcgetpgrp(2));

   /* process owner, groups */
   fprintf(outfile, "user id  = "F_uid"\n", Getuid());
   fprintf(outfile, "effective user id  = "F_uid"\n", Geteuid());
   fprintf(outfile, "group id = "F_gid"\n", Getgid());
   fprintf(outfile, "effective group id = "F_gid"\n", Getegid());

   /* file descriptors */

   Sleep(1);
   return 0;
}
